#include <windows.h>
#include <math.h>

#define CM_OPEN 100
#define CM_SAVE 101

HMENU hMenu1=CreateMenu(),hMenu2=CreateMenu();
HDC hdc;/* "Device context" pentru desen */
PAINTSTRUCT ps;/* Structura pentru desen */
RECT rc;/* Dreptunghiul care da dimensiunea desenului*/

double y,a,b,h,may,miy, v[640];
int ii,i,j,k;
double Pi = 4 * atan ( 1.0 );

double func(double x)
 {
  return sin ( x * Pi / 180 + 1e-3 )/( x * Pi / 180 + 1e-3 ) * 1000 ;
 }
double MAX(double a, double b)
 {
  if (a>b) return a; else return b;
 }
double MIN(double a, double b)
 {
  if (a<b) return a; else return b; 
 }

LRESULT CALLBACK MainWndProc (HWND hwnd, 
															UINT nMsg, 
															WPARAM wParam, 
															LPARAM lParam)
 {
  a=0.01 ; // valoarea inferioara pentru x
  b=3000. ; // valoarea superioara a lui x
  h=(b-a)/640 ;// pasul in reprezentarea grafica
  for (i=0 ; i < 640 ;v[i]=func(a+i*h),i++);//vectorul datelor
  may=v[ 0 ];//********  scalarea
  miy=v[ 0 ];
  for (i=1 ; i<640 ;may=MAX(may,v[i]),miy=MIN(miy,v[i]),i++);
  switch (nMsg)// actualizarea ferestrei
   {
    case WM_DESTROY:
     PostQuitMessage ( 0 );
    return 0 ;
    break ; 

    case WM_COMMAND:
     if ( HIWORD ( wParam ) == BN_CLICKED )
      {
       hdc = GetDC (hwnd);
       if ( LOWORD (wParam) == 100 )//Primul buton
        {//***** trasarea graficului propriu zis
         k=( int )( 300 - (v[ 1 ] - miy)/(may-miy)*300 );
         MoveToEx ( hdc , 1 , k , 0 );// originea
         for ( ii=1 ; ii<640 ;ii++ )
          {
           k=( int )( 300 - (v[ii]-miy)/(may-miy)*300 );
           LineTo ( hdc,ii,k );
          }
        } //grafic
       if ( LOWORD (wParam) == 101 )//al doilea buton
        {// ***** Linie intrerupta la valoarea 0 a functiei    
         SelectObject (hdc, GetStockObject ( SYSTEM_FIXED_FONT )) ;
         k=( int )( 300 + miy / ( may - miy ) * 300 );
         MoveToEx ( hdc , 1 , k , 0 );
         for ( i = 1 ; i < 640 ; i += 3 )
          {
           MoveToEx ( hdc,i,k,0 );
           LineTo ( hdc,i+1 ,k );
          }
        }//linie la 0
       ReleaseDC (hwnd,hdc);
      }//if buton apasat
    return 0 ;
    break ;

    case WM_PAINT:
     hdc = BeginPaint (hwnd,&ps);
     EndPaint (hwnd, &ps);
     return 0 ;
     break ;
   } //end switch
  return DefWindowProc (hwnd, nMsg, wParam, lParam);
 }

int STDCALL WinMain (HINSTANCE hInst,
										 HINSTANCE hPrev,
										 LPSTR lpCmd,
										 int nShow)
 {
  HWND hwndMain;/* "Handle", identificator al ferestrei principale*/
  MSG msg;/* O structura a mesajelor Win32 */
  WNDCLASSEX wndclass;/* O structura a clasei ferestrei */
  char *szMainWndClass = "WinTestWin"; /*  Eticheta cu numele ferestrei */
  /*   La inceput cream clasa aferenta ferestrei noastre */
  /* Initializeaza la 0 intreaga structura */
  memset (&wndclass , 0 , sizeof ( WNDCLASSEX ));

	/* Numele clasei este WinTestWin */
  wndclass.lpszClassName = szMainWndClass;
	/*  cbSize da dimensiunea structurii pentru extensibilitate */
  wndclass.cbSize = sizeof( WNDCLASSEX );
	/*  Toate ferestrele acestei clase sunt redesenate la redimensionare */
  wndclass.style = CS_HREDRAW | CS_VREDRAW ;// | CS_OWNDC|CS_SAVEBITS;
	/*  Fereastra foloseste functia MainWndProc */
  wndclass.lpfnWndProc = MainWndProc;
	/*  Clasa ferestrei este asociata acestei ferestre */
  wndclass.hInstance = hInst;
	/*  Foloseste icoana si cursoarele standard
    ale sistemului de operare */
  wndclass.hIcon = LoadIcon ( NULL , IDI_APPLICATION );
  wndclass.hIconSm = LoadIcon (NULL , IDI_APPLICATION );
  wndclass.hCursor = LoadCursor ( NULL , IDC_ARROW );
	/*  Culoarea de fond este alb */
  wndclass.hbrBackground = ( HBRUSH ) GetStockObject ( WHITE_BRUSH );
	/*  Inregistreaza fereastra */
  RegisterClassEx (&wndclass);
	/*  Creaza fereastra principala  */
  hwndMain = CreateWindow (
    		szMainWndClass,/* Numele ferestrei (clasei)*/
    		"Graficul unei functii",/* Eticheta ferestrei */
    		WS_OVERLAPPEDWINDOW ,/* Stiul */
    		CW_USEDEFAULT ,/* x initial (foloseste valoarea implicita) */
    		CW_USEDEFAULT ,/* y initial (foloseste valoarea implicita) */
    		CW_USEDEFAULT ,/* dimensiunea x initiala (foloseste valoarea implicita) */
    		CW_USEDEFAULT ,/* dimensiunea y initiala (foloseste valoarea implicita) */
    		NULL ,/* Nu avem fereastra parinte */
    		NULL ,/* Fara meniu */
    		hInst,/* "Instanta" acestui program */
    		NULL /* Parametri de creatie */
    		);
    
   AppendMenu ( hMenu2 , MF_STRING , CM_OPEN , "&Grafic" );
   AppendMenu ( hMenu2, MF_SEPARATOR , 0 , NULL );
   AppendMenu ( hMenu2 , MF_STRING , CM_SAVE , "Linie la &y=0");
   SetMenu (hwndMain, hMenu2);

	/*  Afiseaza fereastra creata, folosind nShow, care permite pornirea cu fereastra minimizata */
  ShowWindow (hwndMain, nShow);
  UpdateWindow (hwndMain);
	/*  Principala bucla de mesaje. Toate mesajele trimise catre 
  	  sistemul de operare sunt receptionate prin apelarea functiei 
    	GetMessage care sunt apoi retranmise procedurii corespunzatoare 
    	din programul utilizatorului. Aceasta este cea mai simpla bucla
    	de mesaj. Cand una dintre ferestre cheama PostQuitMessage, 
    	functia GetMessage returneaza 0 si parametrul wParam al mesajului
    	va contine argumentul dat de PostQuitMessage. Bucla va fi terminata
    	iar aplicatia inchisa */
  while (GetMessage (&msg, NULL , 0 , 0 ))
   {
    TranslateMessage (&msg);
    DispatchMessage (&msg);
   }
  return msg.wParam;
 }

