#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define IDB_TILE01  106

HINSTANCE hInst;

char nume[]="c:\\temp\\duci.bmp";//porecla pentru bitmap-ul de fond
double y,h,may,miy, v[ 640 ];
int ii,i,j,k,x_offset = 75 , y_offset = 35 ;
int scala_y=400 , scala_x=600 ;
double Pi = 4 * atan ( 1.0 ) ;
double a=-300 ;// valoarea inferioara pentru x
double b=3000 ;// valoarea superioara pentru y
char eticheta[ 80 ]="1000*sin(x)/x";


double MAX(double x, double y)
 {
  if (x>y) return x; else return y;
 }

double MIN(double x, double y)
 {
  if (x<y) return x; else return y; 
 }

double func(double x)
 {
  double Pi=4*atan(1.0);
//return -x*x+111*x+11;
  return sin(x*Pi/180+1e-3)/(x*Pi/180+1e-3)*1000;
 }

/*functia de reprezentat grafic [-2,1]*/

/*
double a=-2;// valoarea inferioara pentru x
double b=1;// valoarea superioara pentru y
char eticheta[80]="x^4+2x^3-x-1";
double func(double x)
 {
  double xp;
  xp=x*x;
  return xp*xp+2*x*xp-x-1;
 }
*/


LRESULT CALLBACK MainWndProc (HWND hwnd, 
															UINT nMsg, 
															WPARAM wParam, 
															LPARAM lParam)
{
/* Identificatorii "handle" al butoanelor. */

  static HWND hwndButton = 0  , hwndButton1 = 0 , 
  						hwndButton2 = 0 , hwndButton3 = 0 ,
  						hwndButton4 = 0 ;
  static int cx, cy;/* Inaltimea si latimea butoanelor. */
  int deco,semn;
  char *du_str,du_str1[ 80 ] ;
  double temp;
  PAINTSTRUCT ps;/* Structura pentru desen */
  HDC hdc;/* "Device context" pentru desen */
  HBRUSH hBrush;
  HPEN hPen1;
  RECT rc;/* Dreptunghiul care da dimensiunea desenului*/
  TEXTMETRIC tm;//Valorile sistemului pentru dimensiunea caracterelor
	/**************/
  h=(b-a)/scala_x;// pasul in reprezentarea grafica
  for (i=0 ; i < scala_x ; v[i]=func(a+i*h) , i++ );//vectorul datelor
  //********  scalarea datelor
  may=v[ 0 ];
  miy=v[ 0 ];
  for ( i=1 ; i < scala_x ; may=MAX(may,v[i]) , miy=MIN(miy,v[i]) , i++ );
  switch (nMsg)// actualizarea ferestrei
  {
  	case WM_CREATE:
    	hdc = GetDC (hwnd);
    	SelectObject (hdc, GetStockObject ( SYSTEM_FIXED_FONT ));
    	GetTextMetrics (hdc, &tm);
    	cx = tm.tmAveCharWidth * 10;
    	cy = (tm.tmHeight + tm.tmExternalLeading) * 2;
			/* Cream butoanele*/
    	hwndButton = CreateWindow (
       							"button",// Cuvantul cheie pentru BUTON
       							"Grafic",
       							WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
       							685 , 40 , cx, cy,/*pozitie initiala-neimportant*/
       							hwnd,// Fereastra parinte.
       							( HMENU ) 1 ,// Numarul de identificare al butonului: 1
       							(( LPCREATESTRUCT ) lParam)->hInstance,
       							NULL );
    	hwndButton1 = CreateWindow (
       							"button",// Cuvantul cheie pentru BUTON
       							"Linie x=0",
       							WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
       							685 , 90 , cx, cy,
       							hwnd,// Fereastra parinte.
       							( HMENU ) 2 ,// Numarul de identificare al butonului: 2
       							(( LPCREATESTRUCT ) lParam)->hInstance,
       							NULL );
    	hwndButton2 = CreateWindow (
       							"button",// Cuvantul cheie pentru BUTON
       							"Linie y=0",
       							WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
       							685 ,140 , cx, cy,/*pozitie initiala-neimportant*/
       							hwnd,// Fereastra parinte.
       							( HMENU ) 3 ,// Numarul de identificare al butonului: 3
       							(( LPCREATESTRUCT ) lParam)->hInstance,
       							NULL );
    	hwndButton3 = CreateWindow (
       							"button",// Cuvantul cheie pentru BUTON
       							"caroiaj x",
       							WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
       							685 ,190 , cx, cy,/*pozitie initiala-neimportant*/
       							hwnd,// Fereastra parinte.
       							( HMENU ) 4 ,// Numarul de identificare al butonului: 4
       							(( LPCREATESTRUCT ) lParam)->hInstance,
       							NULL );
    	hwndButton4 = CreateWindow (
       							"button",// Cuvantul cheie pentru BUTON
       							"caroiaj y",
       							WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
       							685 ,240 , cx, cy,
       							hwnd,// Fereastra parinte.
       							( HMENU ) 5 ,// Numarul de identificare al butonului: 5
       							(( LPCREATESTRUCT ) lParam)->hInstance,
       							NULL );

    	ReleaseDC (hwnd, hdc);
      // sfarsitul secventei de constructie a butoanelor
   		return 0 ;
   		break ;

  	case WM_DESTROY :
    	PostQuitMessage ( 0 );
   		return 0 ;
   		break ;
  
  	case WM_COMMAND:
   		hdc = BeginPaint (hwnd,&ps);
   		GetClientRect (hwnd,&rc);
		  if ( HIWORD (wParam) == BN_CLICKED )
   		{
     		if ( LOWORD (wParam) == 1 )//Primul buton-graficul propriu zis
      	{
					//************cadrul si axele
					/*Cadrul*/
					hdc = GetDC (hwnd); 
					SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT)) ;
					/*axa X*/
   				hPen1 = CreatePen ( PS_SOLID , 1 , RGB ( 255 , 0 , 0 ));
   				SelectObject (hdc, hPen1) ;
   				MoveToEx (hdc , 75 , 200 , NULL );
   				SetTextColor ( hdc , RGB ( 255 , 255 , 255 ));
   				SetBkMode ( hdc , TRANSPARENT );   
   				MoveToEx ( hdc , x_offset , y_offset+scala_y+3 , NULL );         
					for ( i = 0 ; i <= scala_x ; i += 10 )
					{
   					LineTo   ( hdc,x_offset+i,y_offset+scala_y+3 );
   					LineTo   ( hdc,x_offset+i,y_offset+scala_y+9 );
   					MoveToEx ( hdc,x_offset+i,y_offset+scala_y+3 , NULL );         
					}
					for ( i = 0 ; i <= scala_x ; i += 50 )
					{
   					LineTo (hdc,x_offset+i,y_offset+scala_y+3 );
   					LineTo (hdc,x_offset+i,y_offset+scala_y+15 );
   					temp = a + h * (( double ) i );                     
   					wsprintf (du_str1,"%d",( int ) temp );
   					TextOut (hdc,x_offset+i,y_offset+scala_y+15 ,
   											du_str1,strlen(du_str1));
   					MoveToEx (hdc,x_offset+i,y_offset+scala_y+3 , NULL );         
					}
					/*axa Y*/
 					MoveToEx (hdc,x_offset-3 , y_offset+scala_y,NULL );         
					for ( i = 0 ; i <= scala_y ; i += 10 )
					{
   					LineTo (hdc,x_offset-3 ,y_offset+scala_y-i);
   					LineTo (hdc,x_offset-9 ,y_offset+scala_y-i);
   					MoveToEx (hdc,x_offset-3 ,y_offset+scala_y-i,NULL );         
					}
   				MoveToEx (hdc,x_offset-3 , y_offset+scala_y,NULL );         
					for ( i = 0 ; i <= scala_y ; i += 50 )
					{
  					temp=miy+(( double )i)*(may-miy)/scala_y+0.5 ;
  					wsprintf (du_str1,"%d",(int)temp);
  					TextOut (hdc , 0 ,y_offset+scala_y-i-15 ,du_str1,strlen(du_str1)); 
  					LineTo (hdc,x_offset-3 ,y_offset+scala_y-i);
  					LineTo (hdc,x_offset-15 ,y_offset+scala_y-i);
  					MoveToEx (hdc,x_offset-3 ,y_offset+scala_y-i,NULL );
					}
					//******* trasarea graficului propriu zis
					hPen1 = CreatePen ( PS_SOLID , 1 , RGB ( 255 , 255 , 0 ));
 					SelectObject (hdc, hPen1) ;
       		k=( int )(scala_y-(v[ 1 ]-miy)/(may-miy)*scala_y);
      		MoveToEx (hdc, 1 + x_offset,k+y_offset,NULL );// originea
       		for ( ii = 1 ; ii < scala_x ; ii++)
        	{
        		k=( int )(scala_y-(v[ii]-miy)/(may-miy)*scala_y);
        		LineTo ( hdc , x_offset+ii , y_offset+k );
        	}
      		ReleaseDC (hwnd, hdc);
       		ValidateRect (hwnd, &rc) ;
       		DeleteObject (hPen1);
       		DeleteObject (hBrush);
      	} //grafic
     		if ( (LOWORD (wParam) == 2 ) && ( a<0 && b>0 ) )//al doilea buton -linie la x=0
      	{
					// Linie intrerupta la x=0     
     			hdc = GetDC (hwnd); 
 					hPen1 = CreatePen ( PS_SOLID , 1 , RGB ( 0 , 255 , 255 ));
 					SelectObject (hdc, hPen1) ;
       		k=( int )(x_offset-a/h);
       		MoveToEx (hdc,k,scala_y+y_offset,0 );
       		for ( i = 1 ; i < scala_y ; i += 10 )
        	{
         		MoveToEx (hdc,k,i+y_offset,0 );
         		LineTo (hdc,k,i+ 3 + y_offset );
        	}
       		ReleaseDC (hwnd, hdc) ;
       		ValidateRect (hwnd, &rc) ;
       		DeleteObject (hPen1);
     		}//linie la x=0
     		
     		if (LOWORD (wParam)==3 )//al treilea buton - linie la y=0
      	{
					// Linie intrerupta la valoarea 0 a functiei    
      		hdc = GetDC (hwnd); 
       		SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT)) ;
 					hPen1 = CreatePen ( PS_SOLID , 1 , RGB (0 , 255 , 255 ));
 					SelectObject (hdc, hPen1) ;
        	k=( int )(scala_y+miy/(may-miy)*scala_y)+y_offset;
        	MoveToEx (hdc , 1 + x_offset , k , 0 );
       		for ( i=1 ; i < scala_x ; i += 10 )
        	{
         		MoveToEx (hdc,i+x_offset,k,0 );
         		LineTo (hdc,i + 3 + x_offset,k);
        	}
       		ReleaseDC (hwnd, hdc) ;
       		ValidateRect (hwnd, &rc) ;
        	DeleteObject (hPen1);
     		}//linie la y=0

     		if ( LOWORD (wParam) == 4 )//al patrulea - caroiaj x
      	{
      		hdc = GetDC (hwnd); 
					hPen1 = CreatePen ( PS_SOLID , 1 , RGB (30 , 30 , 30 ));
 					SelectObject (hdc, hPen1) ;
					for ( i = 50 ; i < scala_x ; i += 50 )
					{
   					MoveToEx ( hdc,x_offset+i,y_offset,NULL );         
   					LineTo (hdc,x_offset+i,y_offset+scala_y);
					}
        	DeleteObject (hPen1);
     		}//caroiaj x

     		if ( LOWORD (wParam) == 5 )//al cincilea - caroiaj y
      	{
      		hdc = GetDC (hwnd); 
					hPen1 = CreatePen( PS_SOLID , 1 , RGB ( 30 , 30 , 30 ));
 					SelectObject (hdc, hPen1) ;
					for ( i = 50 ; i < scala_y ; i += 50 )
					{
   					MoveToEx (hdc,x_offset,y_offset+i,NULL );         
   					LineTo (hdc,x_offset+scala_x,y_offset+i);
					}
       		DeleteObject (hPen1);
     		}//caroiaj y
   		}//if buton apasat
   		EndPaint (hwnd, &ps);
   		return 0 ;
   		break ;

  	case WM_SIZE: // Schimbarea dimensiunii ferestrei
			//    Plaseaza butoanele la mijloc 
  		if (
      	  (hwndButton ||hwndButton1)
        	&&
        	(wParam == SIZEFULLSCREEN || wParam == SIZENORMAL)
    	 	 )
  		{
     		// Dimensiunile dreptunghiului de referinta "rc"
  			rc.left = 670 ;//(LOWORD(lParam) - cx) / 2;
    		rc.top = HIWORD (lParam) * 3 / 4 - cy / 2 ;
    		UpdateWindow ( hwnd );
  		}
  		return 0 ;
  		break ;
  
  	case WM_PAINT:
			hdc = BeginPaint (hwnd,&ps);
			GetClientRect (hwnd,&rc);
			// O umbra a ariei de plotare
			hBrush= CreateSolidBrush (RGB ( 91 , 91 , 91 )) ;
			SelectObject (hdc, hBrush) ;
			hPen1 = CreatePen ( PS_SOLID , 3 , RGB (91 , 91 ,91 ));
			SelectObject (hdc, hPen1) ;
			Rectangle (hdc, x_offset + 5 , y_offset - 5 ,
										x_offset + scala_x + 5 , 
										y_offset + scala_y - 5 );
			DeleteObject (hPen1);
			DeleteObject (hBrush);
			/*-----------*/
			hBrush= CreateSolidBrush (RGB ( 0 , 0 , 0 )) ;
			SelectObject (hdc, hBrush) ;
			hPen1 = CreatePen ( PS_SOLID , 3 , RGB ( 255 , 0 , 0 ));
			SelectObject (hdc, hPen1) ;
			Rectangle (hdc, x_offset - 3 , y_offset - 3 ,
										x_offset + scala_x + 3 ,
										y_offset + scala_y + 3 );
			DeleteObject (hBrush);
			DeleteObject (hPen1);
			SetBkMode (hdc, TRANSPARENT ); 
			TextOut (hdc,( int )(x_offset + scala_x/2 - 100 ),
									5 , eticheta , strlen(eticheta) );
   		EndPaint (hwnd, &ps);                        
  		return 0 ;
  		break ;
	} //end switch
 return DefWindowProc (hwnd, nMsg, wParam, lParam);
 }

int STDCALL WinMain (HINSTANCE hInst,
                     HINSTANCE hPrev,
                     LPSTR lpCmd,
                     int nShow)
{
	HWND hwndMain;// "Handle", identificator al ferestrei principale
  MSG msg;// O structura a mesajelor Win32 
  WNDCLASSEX wndclass;// O structura a clasei ferestrei 
  HBITMAP hBmp;
  HBRUSH hbr;
  char*szMainWndClass = "WinTestWin"; //  Eticheta cu numele ferestrei 
	//   La inceput cream clasa aferenta ferestrei noastre 
	// Initializeaza la 0 intreaga structura 
  memset (&wndclass, 0, sizeof ( WNDCLASSEX ));
	// Numele clasei este WinTestWin 
  wndclass.lpszClassName = szMainWndClass;
	//  cbSize da dimensiunea structurii pentru extensibilitate 
  wndclass.cbSize = sizeof ( WNDCLASSEX );
	//  Toate ferestrele acestei clase sunt redesenate la redimensionare 
  wndclass.style = CS_HREDRAW | CS_VREDRAW ;
	//  Toate ferestrele acestei clase folosesc functia  MainWndProc 
  wndclass.lpfnWndProc = MainWndProc;
	//  Clasa ferestrei este asociata acestei ferestre 
  wndclass.hInstance = hInst;
	//  Foloseste icoana si cursoarele standard ale sistemului de operare 
  wndclass.hIcon = LoadIcon ( NULL , IDI_APPLICATION );
  wndclass.hIconSm = LoadIcon ( NULL , IDI_APPLICATION );
  wndclass.hCursor = LoadCursor ( NULL , IDC_ARROW );
  //wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
	//  Culoarea de fond este ... 
	//hBmp=LoadBitmap (hInst, nume) ;//folosim porecla nume data resursei
	//hbr =CreatePatternBrush(hBmp);
	hbr = CreateSolidBrush ( RGB ( 100 , 100 , 110 ) );
  wndclass.hbrBackground = hbr;//(HBRUSH) GetStockObject (WHITE_BRUSH);
	//  Inregistreaza fereastra 
  RegisterClassEx (&wndclass);
	// Creaza fereastra principala  
  hwndMain = CreateWindow (
    szMainWndClass,// Numele ferestrei (clasei)
    "Graficul unei functii            D. Ciurchea(UBB) 2002 ",// Eticheta ferestrei 
    WS_OVERLAPPEDWINDOW ,// Stiul 
    1 ,// x initial (se poate folosi valoarea implicita CW_USEDEFAULT) 
    1 ,// y initial 
    780 ,// dimensiunea x initiala 
    500 ,// dimensiunea y initiala 
    NULL ,// Nu avem fereastra parinte 
    NULL ,// Fara meniu 
    hInst ,// "Instanta" acestui program 
    NULL// Parametri de creatie 
    );
	/*  
  	Afiseaza fereastra creata, folosind nShow, 
  	care permite pornirea cu fereastra minimizata 
	*/
  ShowWindow (hwndMain, nShow);
  UpdateWindow (hwndMain);
	/*  Principala bucla de mesaje. Toate mesajele trimise catre 
    	sistemul de operare sunt receptionate prin apelarea functiei 
    	GetMessage care sunt apoi retranmise procedurii corespunzatoare 
    	din programul utilizatorului. Aceasta este cea mai simpla bucla
    	de mesaj. Cand una dintre ferestre cheama PostQuitMessage, 
    	functia GetMessage returneaza 0 si parametrul wParam al mesajului
    	va contine argumentul dat de PostQuitMessage. Bucla va fi terminata
    	iar aplicatia inchisa 
	*/
  while (GetMessage ( &msg , NULL , 0 , 0 ))
  {
  	TranslateMessage (&msg);
    DispatchMessage (&msg);
  }
  return msg.wParam;
}
