#include <windows.h>
#include <string.h>
#include <direct.h>
#include <math.h>

#define  MAXPATH     256
#define  MAXREAD     58534

HWND  hwnd,hwnd0=0 ;
BOOL fValidBox;
HINSTANCE hInstance;
PAINTSTRUCT ps;/* Structura pentru desen */
HBRUSH hBrush;
HPEN hPen1;
RECT rc;/* Dreptunghiul care da dimensiunea desenului*/

LRESULT CALLBACK WndProc  (HWND , UINT , WPARAM , LPARAM ) ;
LRESULT CALLBACK ListProc (HWND , UINT , WPARAM , LPARAM ) ;
WNDPROC fnOldList ;

#define MAXLEN 32

double Pi=4*atan ( 1.0 );
char du_str1 [ 100 ] ;
int flag=0 , flag1=0 ,flag2=0 ;
double t[ 120000 ], d[ 120000 ], dcalc[ 12000 ];
int contor_p,x_offset=220 ,y_offset=25 ,scala_x=500 ,scala_y=410 ;
double aa,bb,y,h,may,miy,temp;
double x_min,x_max,y_min,y_max;
double aa0,bb0,may0,miy0;
int    i_min=0,i_max;
int	   i,ii,k,l;

double MAX(double x, double y)
{
    if (x>=y) return x; 
    else return y;
}

double MIN(double x, double y)
{
    if (x<=y) return x; 
    else return y;
}

void DrawBoxOutline (HWND hwnd, POINT ptBeg, POINT ptEnd)
{
    HDC hdc ;
    hdc = GetDC (hwnd) ;
    hPen1= CreatePen ( PS_SOLID , 3 , RGB (0 , 255 , 0 ) ) ;
    SetROP2 (hdc, R2_NOT ) ;
    SelectObject (hdc, GetStockObject ( GRAY_BRUSH )) ;
    Rectangle (hdc, ptBeg.x, ptBeg.y, ptEnd.x, ptEnd.y) ;
    DeleteObject (hPen1);
    ReleaseDC (hwnd, hdc) ;
}

void cadru()
{
    if (i_min<0 || i_min > 120000 ) return ;
    if (i_min==i_max) return ;
    HDC hdc;
    RECT rct;
    hdc = GetDC (hwnd); 
    hPen1 = CreatePen ( PS_SOLID , 1 , RGB (122 , 122 , 122 ));
    SelectObject (hdc, hPen1) ;
    hBrush= CreateSolidBrush (RGB ( 122 , 122 , 122 )) ;
    SelectObject (hdc, hBrush) ;
    SetBkColor (hdc,RGB ( 122 , 122 , 122 ));
    SelectObject (hdc, GetStockObject ( ANSI_VAR_FONT )) ;
    rct.top=y_offset-80 ;
    rct.bottom=y_offset+scala_y+80 ;
    rct.left=x_offset-98 ;
    rct.right=x_offset+scala_x+60 ;
    FillRect (hdc,&rct,hBrush);
    Rectangle (hdc, x_offset-60 ,
    							  y_offset-30 ,
                    x_offset+scala_x+30 ,
                    y_offset+scala_y+60 );
    DeleteObject (hBrush);
    DeleteObject (hPen1);
    /*****dreptunghiul******************/
    hBrush = CreateSolidBrush (RGB ( 0 , 0 , 0 )) ;
    SelectObject (hdc, hBrush) ;
    Rectangle (hdc, x_offset-1 ,
    								y_offset-1 ,
    								x_offset+scala_x+1 ,
    								y_offset+scala_y+1 );
    DeleteObject (hBrush);
		SetBkMode (hdc, OPAQUE );
 		SetTextAlign (hdc, TA_NOUPDATECP |TA_CENTER );	   
    //- caroiaj x
    hPen1 = CreatePen ( PS_SOLID , 1 , RGB (30 ,30 ,30 ) );
    SelectObject (hdc, hPen1) ;
    for ( i=50 ; i<scala_x ; i+=50 )
    {
        MoveToEx (hdc,x_offset+i,y_offset,NULL );         
        LineTo ( hdc,x_offset+i,y_offset+scala_y);
    }
    // - caroiaj y
    for (i=50 ; i < scala_y ; i += 50 )
    {
        MoveToEx (hdc,x_offset,y_offset+i,NULL );         
        LineTo (hdc,x_offset+scala_x,y_offset+i);
    }
    DeleteObject (hPen1);
    //************cadrul si axele
    //axa X
    hPen1 = CreatePen ( PS_SOLID , 1 , RGB ( 255 , 255 , 255 ));
    SelectObject (hdc, hPen1) ;
    MoveToEx (hdc,75 , 200 , NULL );
    SetTextColor (hdc,RGB ( 255 , 255 , 255 ));
    SetBkMode ( hdc , OPAQUE );
    MoveToEx ( hdc,x_offset,y_offset+scala_y,NULL );
    for (i=0 ; i<=scala_x ; i+=10 )
    {
        LineTo (hdc,x_offset+i,y_offset+scala_y );
        LineTo (hdc,x_offset+i,y_offset+scala_y+9 );
        MoveToEx (hdc,x_offset+i,y_offset+scala_y,NULL );         
    }
    for (i=0 ; i <= scala_x ; i += 50 )
    {
        LineTo   (hdc,x_offset+i,y_offset+scala_y );
        LineTo   (hdc,x_offset+i,y_offset+scala_y+19 );
        sprintf  (du_str1,"%6.2f  ",( float )(aa+h*(( double )i)));
        TextOut  (hdc,x_offset+i,y_offset+scala_y+19 ,
                 							du_str1,strlen (du_str1));
        MoveToEx (hdc,x_offset+i,y_offset+scala_y,NULL );         
    }
    //axa Y
    MoveToEx (hdc,x_offset,y_offset+scala_y,NULL );         
    for (i=0 ; i <= scala_y ; i += 10 )
    {
        LineTo   (hdc,x_offset,y_offset+scala_y-i);
        LineTo   (hdc,x_offset-9 ,y_offset+scala_y-i);
        MoveToEx (hdc,x_offset,y_offset+scala_y-i,NULL );         
    }
    MoveToEx (hdc,x_offset,y_offset+scala_y,NULL );         
    for (i=0 ; i<=scala_y ; i += 50 )
    {
        sprintf  ( du_str1,"%6.2e   ",
                      ( float )(miy+i*(may-miy)/scala_y));
        TextOut  (hdc,x_offset-45 ,y_offset+scala_y-i-19 ,
                              du_str1,strlen (du_str1));
        LineTo   (hdc,x_offset,y_offset+scala_y-i);
        LineTo   (hdc,x_offset-15 ,y_offset+scala_y-i );
        MoveToEx (hdc,x_offset,y_offset+scala_y-i,NULL );         
    }
    /*********************/
    if (flag==0)
    {
        hPen1  = CreatePen ( PS_SOLID , 1 , RGB ( 255 , 255 , 205 ));
        hBrush = CreateSolidBrush ( RGB ( 255 , 0 , 55 ));
        SelectObject (hdc, hPen1); 
        SelectObject (hdc, hBrush);
        k=( int )(scala_y+y_offset-(d[i_min]-miy)/(may-miy)*scala_y);
        l=( int )(x_offset+(t[i_min]-aa)/(bb-aa)*((double)scala_x));
        MoveToEx ( hdc , l , k , NULL );// originea
        for ( ii=i_min ; ii<=contor_p ; ii++ )
        {
            k = ( int ) ( scala_y+y_offset - (d[ii]-miy)/(may-miy)*scala_y);
            l= ( int )(x_offset+(t[ii]-aa)/(bb-aa)*((double)scala_x));
            if ( t[ii] >=aa && t[ii]<=bb && d[ii]<=may && d[ii]>=miy)
                Ellipse (hdc , l-3 , k-3 , l+3 , k+3 );
        }
        DeleteObject (hPen1);
        DeleteObject (hBrush);
    }//if flag
    hPen1 = CreatePen ( PS_SOLID , 1 , RGB ( 255 , 255 , 0 ));
    SelectObject (hdc, hPen1) ;
    k=( int )(scala_y+y_offset-(dcalc[i_min]-miy)/(may-miy)*scala_y);
    l=( int )(x_offset+(t[i_min]-aa)/(bb-aa)*((double)scala_x));
    MoveToEx (hdc,l,k,NULL );// originea
    for (ii=i_min ; ii <= contor_p ; ii++ )
    {
    	k=(int)(scala_y+y_offset-(dcalc[ii]-miy)/(may-miy)*scala_y);
    	l=(int)(x_offset+(t[ii]-aa)/(bb-aa)*((double)scala_x));
    	if (t[ii]>=aa && t[ii]<=bb && d[ii]<=may && d[ii]>=miy)
      		LineTo (hdc,l,k);
    }
    DeleteObject ( hPen1 );
    ReleaseDC (hwnd,hdc);
}

int WINAPI WinMain (HINSTANCE hInstance, 
										HINSTANCE hPrevInstance,
										PSTR szCmdLine, 
										int iCmdShow)
{
    static char szAppName[] = "sunny" ;
    MSG         msg ;
    WNDCLASSEX  wndclass ;
    wndclass.cbSize        = sizeof (wndclass) ;
    wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
    wndclass.lpfnWndProc   = WndProc ;
    wndclass.cbClsExtra    = 0 ;
    wndclass.cbWndExtra    = 0 ;
    wndclass.hInstance     = hInstance ;
    wndclass.hIcon         = LoadIcon ( NULL , IDI_APPLICATION ) ;
    wndclass.hCursor       = LoadCursor (NULL , IDC_ARROW ) ;
    wndclass.hbrBackground = ( HBRUSH ) GetStockObject ( LTGRAY_BRUSH );
    wndclass.lpszMenuName  = NULL ;
    wndclass.lpszClassName = szAppName ;
    wndclass.hIconSm       = LoadIcon ( NULL , IDI_APPLICATION ) ;
    RegisterClassEx (&wndclass) ;
    hwnd = CreateWindow ( szAppName,
         "Citeste si deseneaza fisiere *.dat cu 2 si 3 coloane    ..:: D. Ciurchea 2003 ::..",
    											WS_OVERLAPPEDWINDOW | WS_SYSMENU ,
    											10 ,10 ,780 ,520 ,
    											NULL , NULL , hInstance , NULL ) ;
    ShowWindow (hwnd, iCmdShow) ;
    UpdateWindow (hwnd) ;
    while (GetMessage (&msg, NULL , 0 , 0 ))
    {
        TranslateMessage (&msg) ;
        DispatchMessage (&msg) ;
    }
    return msg.wParam ;
}

LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
    static BOOL     bValidFile ;
    static char     sReadBuffer[MAXREAD ], szFile[MAXPATH ] ;
    static HWND     hwndList, hwndText ,buton;
    static OFSTRUCT ofs ;
    static RECT     rect ;
    char            szBuffer[MAXPATH + 1 ],szBuff1[ 100 ] ;
    HDC             hdc ;
    int             iHandle, i,i_col;
    TEXTMETRIC      tm ;
    static BOOL  		fBlocking,fLock;
    static POINT 		ptBeg, ptEnd, ptBoxBeg, ptBoxEnd ;
    //--------------pozitie mouse
    static int 			LB=0,RB=0;        // Starea butoanelor mouse
    static int 			X=0,Y=0;               // Pozitie mouse
    char 						szBuff[ 128 ];   
    
    GetClientRect (hwnd, &rc);
    switch (iMsg)
    {
    	case WM_CREATE :
        hdc = GetDC (hwnd) ;
        SelectObject (hdc, GetStockObject ( OEM_FIXED_FONT )) ;
        GetTextMetrics (hdc, &tm) ;
        ReleaseDC (hwnd, hdc) ;
        rect.left = 20 * tm.tmAveCharWidth ;
        rect.top  =  3 * tm.tmHeight ;
        hwndList = CreateWindow ("listbox","Fisiere disponibile",
        										WS_CHILDWINDOW | WS_VISIBLE |
            								LBS_STANDARD | WS_CAPTION ,
        										1 , 5 ,
        										tm.tmAveCharWidth * 13 + GetSystemMetrics ( SM_CXVSCROLL ),
        										380,//tm.tmHeight * 10 ,
        										hwnd, ( HMENU ) 1 ,
        										( HINSTANCE ) GetWindowLong ( hwnd, GWL_HINSTANCE ),
        										NULL ) ;
        CreateWindowEx (0 , TEXT ("BUTTON"),
        										TEXT ("Cu puncte"),	
        										WS_CHILD | WS_VISIBLE | BS_CHECKBOX |  WS_THICKFRAME ,
            								13 , 414 , 90 ,25 , 
        										hwnd,( HMENU ) 7 ,
        										hInstance, NULL ); 
        CheckDlgButton (hwnd ,7 ,BST_CHECKED );  
        flag = 0 ;
        CreateWindowEx (0 , TEXT ("BUTTON"),
        										TEXT ("3 coloane"),	
        										WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_THICKFRAME ,
            								13 ,384 ,90 ,25 , 
        										hwnd,( HMENU ) 8 ,
        										hInstance, NULL ); 
        CheckDlgButton (hwnd,8 ,BST_CHECKED );  
        flag2= 0 ; 
        i_col= 3 ;
        CreateWindowEx (0 , TEXT ("BUTTON"),
        										TEXT ("Edit window"),	
        										WS_CHILD | WS_VISIBLE | BS_PUSHLIKE | WS_THICKFRAME ,
            								13 ,444 ,90 ,25 , 
        										hwnd,( HMENU ) 9 ,
        										hInstance, NULL ); 
        ReleaseDC (hwnd,hdc);
        fnOldList = ( WNDPROC ) 
        										SetWindowLong (hwndList, GWL_WNDPROC , ( LPARAM ) ListProc) ;
        SendMessage (hwndList, LB_DIR , 0x37 , ( LPARAM ) "*.*") ;
        return 0 ;

    	case WM_SIZE :
        rect.right  = LOWORD (lParam) ;
        rect.bottom = HIWORD (lParam) ;
        return 0 ;

    	case WM_SETFOCUS :
        SetFocus (hwndList) ;
        return 0 ;

    	case WM_RBUTTONDOWN : 
      {
      	DestroyWindow (hwnd0);
        aa=aa0;
        bb=bb0;
        h=(bb-aa)/scala_x;
        may=may0;
        miy=miy0;
        i_min=0;
        i_max=contor_p;
        if (fValidBox) cadru();
      }
      break ;

    	case WM_LBUTTONDOWN  :
        ptBeg.x = ptEnd.x = LOWORD (lParam);
        ptBeg.y = ptEnd.y = HIWORD (lParam);
        DrawBoxOutline (hwnd, ptBeg, ptEnd);
        SetCursor (LoadCursor (NULL , IDC_CROSS ));
        fBlocking = TRUE ;
        return 0 ;

    	case WM_MOUSEMOVE :
        if (fBlocking)
        {
        	SetCursor (LoadCursor (NULL, IDC_CROSS )) ;
          hPen1= CreatePen ( PS_SOLID , 3 , RGB (0 ,255 ,0 ));
          DrawBoxOutline (hwnd , ptBeg, ptEnd) ;
          ptEnd.x = LOWORD (lParam) ;
          ptEnd.y = HIWORD (lParam) ;
          DrawBoxOutline (hwnd, ptBeg, ptEnd) ;
          DeleteObject (hPen1);
        }
        return 0 ;

    	case WM_LBUTTONUP :
        if ( fBlocking )
        {
        	hPen1= CreatePen ( PS_SOLID , 3 , RGB (0 ,255 ,0 ));
          DrawBoxOutline (hwnd, ptBeg, ptEnd) ;
          ptBoxBeg   = ptBeg ;
          ptBoxEnd.x = LOWORD (lParam) ;
          ptBoxEnd.y = HIWORD (lParam) ;
          SetCursor (LoadCursor (NULL , IDC_ARROW )) ;
          fBlocking = FALSE ;
          if (ptBoxBeg.x!=ptBoxEnd.x && ptBoxBeg.y!=ptBoxEnd.y)
          				fValidBox  = TRUE ;
          else return 0;
          DeleteObject (hPen1);
          InvalidateRect ( hwnd , NULL , TRUE ) ;
          temp=(ptBoxBeg.x-x_offset)*h+aa;
          bb=(ptBoxEnd.x-x_offset)*h+aa;
          aa=temp;
          h=(bb-aa)/scala_x;
          for (i_min=120000 ,i_max=0,i=0;i<=contor_p;i++)
          				if (t[i]>=aa && t[i]<=bb)
                	{
                  	i_min=( int )MIN(i_min,i);
                    i_max=( int )MAX(i_max,i);
                	}
           if ( i_min<0 || i_min > 120000 )i_min = 0 ;
           for ( may=-1e20 ,miy=1e20 , i=0 ;i_min>=0 , i<=contor_p ; i++ )
                	if ( t[i]>=aa && t[i]<=bb )
                	{
                  	may = MAX ( may , d[i] ) ;
                    miy=MIN(d[i],miy);
                    may=MAX(may,dcalc[i]);
                    miy=MIN(dcalc[i],miy);
                    i_max++;
                	}
            
        }
        return 0 ;
        break ;     
        
    	case WM_CHAR :
        if (fBlocking & wParam == '\x1B')       // ie, Escape
        {
        	DrawBoxOutline (hwnd, ptBeg, ptEnd) ;
          SetCursor (LoadCursor (NULL , IDC_ARROW )) ;
          fBlocking = FALSE ;
        }
        return 0 ;

    	case WM_COMMAND :
       	hwnd0 = 0 ;
        if ( LOWORD (wParam) ==7  && HIWORD (wParam) == BN_CLICKED )
        {
        	if ( flag==1 )
          {         
          	flag=0 ;
            CheckDlgButton ( hwnd , 7 , BST_CHECKED );
          }
          else 
          {    
           flag = 1 ; 
           CheckDlgButton ( hwnd , 7 , BST_UNCHECKED );
          }
          if ( flag1 == 1 ) cadru() ;
        } //buton 7
        if ( LOWORD (wParam) == 8  &&  HIWORD (wParam) == BN_CLICKED )
        {
        	if ( flag2 == 1 )
          {         
          	flag2 = 0 ;
            CheckDlgButton ( hwnd , 8 , BST_CHECKED );
          }
          else 
          {    
          	flag2 = 1 ; 
            CheckDlgButton ( hwnd , 8 , BST_UNCHECKED ) ; 
          }
          cadru();
        } //buton 8
				if ( HIWORD (wParam)== BN_CLICKED && LOWORD (wParam)==9 )
				{
   				if (hwnd0 == 0 )
    			{
     				hwnd0 = CreateWindow ( "edit",
         													"",
    															WS_OVERLAPPEDWINDOW | WS_VSCROLL |
    															WS_CHILD | WS_SYSMENU | WS_SIZEBOX
    															| WS_CLIPCHILDREN | WS_CLIPSIBLINGS
   																| ES_WANTRETURN  | ES_LEFT | ES_MULTILINE 
   																| ES_AUTOVSCROLL ,
    															150 ,10 ,620 ,420 ,
    															hwnd,( HMENU ) 6, hInstance, NULL) ;
    				ShowWindow (hwnd0,SW_SHOWNORMAL );
            if ( bValidFile && -1 != (iHandle =
            					    OpenFile (szFile, &ofs, OF_REOPEN | OF_READ )))
            {
            	ZeroMemory (sReadBuffer,strlen (sReadBuffer));
              i = _lread (iHandle, sReadBuffer, MAXREAD ) ;
              _lclose (iHandle) ;
    					SendMessage (hwnd0, WM_SETTEXT , 0 , (LPARAM ) sReadBuffer);
     				}
    			}
				}
        if ((LOWORD (wParam) == 1 && HIWORD (wParam) == LBN_SELCHANGE )
            ||( LOWORD (wParam)==8 && ( HIWORD (wParam)== BST_CHECKED ||
                                        HIWORD (wParam)== BST_UNCHECKED )))

        {
        	if ( LB_ERR ==(i = SendMessage (hwndList,LB_GETCURSEL , 0 , 0L )))
                              break ;
          SendMessage (hwndList, LB_GETTEXT , i, (LPARAM) szBuffer) ;
          if (-1 != OpenFile (szBuffer, &ofs, OF_EXIST | OF_READ ))
          {
          	bValidFile = TRUE ;
            strcpy (szFile, szBuffer) ;
            getcwd (szBuffer, MAXPATH ) ;
            if (szBuffer [strlen (szBuffer) - 1] != '\\' )
            strcat (szBuffer, "\\") ;
            SetWindowText (hwnd, strcat (szBuffer, szFile)) ;
          }
          else
          {
          	DestroyWindow (hwnd0);
            bValidFile = FALSE ;
            szBuffer [strlen (szBuffer) - 1] = '\0' ;
            chdir (szBuffer + 1 ) ;
            getcwd (szBuffer, MAXPATH ) ;
            SendMessage (hwndList, LB_RESETCONTENT , 0 , 0L ) ;
						//cu DlgDirList pune si unitatile logice
            DlgDirList (hwnd,szBuffer, 1 , 0 ,
                         DDL_DRIVES | DDL_DIRECTORY | DDL_ARCHIVE );
          }//else
          InvalidateRect (hwnd, NULL , TRUE ) ;
        }// 1 si 8
        if (bValidFile)
        {
        	FILE *fp=fopen (szFile,"rt");
          contor_p=0 ;
          may=-1e20 ;
          miy=1e20 ;
          contor_p=0 ;
          if( flag2 == 0 )//i_col==3
          {
          	while ( !feof (fp) )
            {
            	if (( i_col=fscanf (fp,"%lf %lf %lf\n",
            	                   &t[contor_p],&d[contor_p],&temp))==3)
              {
              	flag1=1 ; //if(i_col==3)
                dcalc[contor_p]=temp;
                //scalarea datelor dupa y            
                may=MAX(may,d[contor_p]);
                miy=MIN(miy,d[contor_p]);
                may=MAX(may,dcalc[contor_p]);
                miy=MIN(miy,dcalc[contor_p]);
                contor_p++;
              }
              else
              {
             	 flag1=0 ;
               return 0 ;
              } 
            } //while !feof
            contor_p--  ;
            fclose (fp) ;
            aa=t[ 0 ] ;
            aa0=aa ;
            bb = t[contor_p] ;
            bb0=bb;
            h=(bb-aa)/scala_x;//scalarea datelor dupa x
            may0=may;
            miy0=miy;
            i_min=0 ;
            i_max=contor_p;
          }//if i_col==3

          if ( flag2==1 )//i_col==2
          {
          	while ( !feof (fp) )
            {
            	if( i_col=( fscanf (fp,"%lf %lf \n",&t[contor_p],&d[contor_p]))==2)
              {
              	flag1=1 ; //if(i_col==2)
                dcalc[contor_p]=d[contor_p];
                //scalarea datelor dupa y            
                may=MAX(may,d[contor_p]);
                miy=MIN(miy,d[contor_p]);
                contor_p++;
              }
              else
              {
              	flag1=0 ;
                return 0 ;
              } 
              // if fscanf==2
            } //while !feof
            contor_p--;
            fclose (fp);
            aa=t[ 0 ] ;
            aa0=aa;
            bb=t[contor_p];
            bb0=bb;
            h=(bb-aa)/scala_x;//scalarea datelor dupa x
            may0=may;
            miy0=miy;
            i_min=0 ;
            i_max=contor_p;
          }//if i_col==2
        }//if bValidFile
      	return 0 ;
      	break ;

    	case WM_PAINT:
        BeginPaint (hwnd,&ps);
        hdc = GetDC (hwnd) ;
        GetClientRect (hwnd,&rc);
        SelectObject (hdc, GetStockObject ( ANSI_FIXED_FONT )) ;
        SetTextColor (hdc, RGB (0 ,0 ,0 ));
        SetBkColor (hdc,RGB (192 ,192 ,192 )) ;
        if (bValidFile && flag1==1 && !hwnd0 ) cadru();
        else
        {
        	if (bValidFile && -1 != (iHandle =
          		     OpenFile ( szFile, &ofs, OF_REOPEN | OF_READ ))&&!hwnd0)
          {
          	i = _lread (iHandle, sReadBuffer, MAXREAD ) ;
            _lclose (iHandle) ;
        		DrawText (hdc,sReadBuffer, i, &rect, DT_WORDBREAK  | 
                         DT_EXPANDTABS | DT_NOCLIP | DT_NOPREFIX ) ;
          }
        }
        if (fValidBox)
        {
            SelectObject (hdc, GetStockObject (HOLLOW_BRUSH )) ;
            SelectObject (hdc, GetStockObject (NULL_PEN )) ;            
            Rectangle (hdc, ptBoxBeg.x, ptBoxBeg.y,
            								ptBoxEnd.x, ptBoxEnd.y) ;
        }
        if (fBlocking)
        {
        	SetROP2 (hdc, R2_MASKPEN) ;
          SelectObject (hdc, GetStockObject (HOLLOW_BRUSH )) ;
          SelectObject (hdc, GetStockObject (NULL_PEN )) ;
          Rectangle (hdc, ptBeg.x, ptBeg.y, ptEnd.x, ptEnd.y) ;
        }
        ReleaseDC (hwnd,hdc);
        EndPaint (hwnd,&ps);
        return 0 ;

    	case WM_DESTROY :
        PostQuitMessage ( 0 ) ;
        return 0 ;
    }
    
    ReleaseDC (hwnd,hdc);
    return DefWindowProc (hwnd, iMsg, wParam, lParam) ;
}


LRESULT CALLBACK ListProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	if (iMsg == WM_KEYDOWN && wParam == VK_RETURN )
        SendMessage (GetParent (hwnd), WM_COMMAND , 1 ,
        MAKELONG (hwnd, LBN_DBLCLK )) ;
  return CallWindowProc (fnOldList, hwnd, iMsg, wParam, lParam) ;
}
