#include <windows.h>
#include <math.h>

double y,a,b,h,may,miy, v[640];
int ii,i,j,k;
double Pi=4*atan(1.0);
double func(double x)
 {
  return sin(x*Pi/180+1e-3)/(x*Pi/180+1e-3)*1000;
 }
double MAX(double a, double b)
 {
  if (a>b) return a; else return b;
 }
double MIN(double a, double b)
 {
  if (a<b) return a; else return b; 
 }

LRESULT CALLBACK
   MainWndProc (HWND hwnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
 {
/* Identificatorii "handle" al butoanelor. */

  static HWND hwndButton = 0;
  static HWND hwndButton1 = 0;
  static int cx, cy;/* Inaltimea si latimea butoanelor. */
  int apasat1=0,apasat2=0;
  HDC hdc;/* "Device context" pentru desen */
  PAINTSTRUCT ps;/* Structura pentru desen */
  RECT rc;/* Dreptunghiul care da dimensiunea desenului*/
  TEXTMETRIC tm;//Valorile sistemului pentru dimensiunea caracterelor
/***********************/
  a=0.01; // valoarea inferioara pentru x
  b=3000.; // valoarea superioara a lui x
  h=(b-a)/640;// pasul in reprezentarea grafica
  for (i=0;i<640;v[i]=func(a+i*h),i++);//vectorul datelor
  //********  scalarea
  may=v[0];
  miy=v[0];
  for (i=1;i<640;may=MAX(may,v[i]),miy=MIN(miy,v[i]),i++);

  switch (nMsg)// actualizarea ferestrei
   {
    case WM_CREATE:
    hdc = GetDC (hwnd);
    SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT));
    GetTextMetrics (hdc, &tm);
    cx = tm.tmAveCharWidth * 10;
    cy = (tm.tmHeight + tm.tmExternalLeading) * 2;
    ReleaseDC (hwnd, hdc);
/* Cream butoanele*/
    hwndButton = CreateWindow (
       "button",// Cuvantul cheie pentru BUTON
       "Grafic",
       WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
       0,0, cx, cy,/*pozitie initiala-neimportant*/
       hwnd,// Fereastra parinte.
       (HMENU) 1,// Numarul de identificare al butonului: 1
       ((LPCREATESTRUCT) lParam)->hInstance,
       NULL );
    hwndButton1 = CreateWindow (
       "button",// Cuvantul cheie pentru BUTON
       "Linie",
       WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
       0,0, cx, cy,
       hwnd,// Fereastra parinte.
       (HMENU) 2,// Numarul de identificare al butonului: 2
       ((LPCREATESTRUCT) lParam)->hInstance,
       NULL);
      // sfarsitul secventei de constructie a butoanelor
   return 0;
  break;

  case WM_DESTROY:
   PostQuitMessage (0);
   return 0;
  break;
  case WM_COMMAND:
   hdc=BeginPaint(hwnd,&ps);
   GetClientRect(hwnd,&rc);
   if ( HIWORD(wParam) == BN_CLICKED )
    {
     if(LOWORD(wParam)==1)//Primul buton
      {
       hdc = GetDC (hwnd); 
       SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT)) ;
//******* trasarea graficului propriu zis
       k=(int)(300-(v[1]-miy)/(may-miy)*300);
       MoveToEx(hdc,1,k,0);// originea
       for(ii=1;ii<640;ii++)
        {
         k=(int)(300-(v[ii]-miy)/(may-miy)*300);
         LineTo(hdc,ii,k);
        }
       ReleaseDC (hwnd, hdc);
       ValidateRect (hwnd, &rc) ;
      } //grafic

     if(LOWORD(wParam)==2)//al doilea buton
      {
/* Linie intrerupta la valoarea 0 a functiei    */
       hdc = GetDC (hwnd); 
       SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT)) ;
       k=(int)(300+miy/(may-miy)*300);
       MoveToEx(hdc,1,k,0);
       for(i=1;i<640;i+=3)
        {
         MoveToEx(hdc,i,k,0);
         LineTo(hdc,i+1,k);
        }
       ReleaseDC (hwnd, hdc) ;
       ValidateRect (hwnd, &rc) ;
     }//linie la 0
    }//if buton apasat
   EndPaint (hwnd, &ps);
  return 0;
  break;

  case WM_SIZE: // Schimbarea dimensiunii ferestrei
   /* Plaseaza butoanele la mijloc */
  if (
       (hwndButton ||hwndButton1)
       &&
       (wParam == SIZEFULLSCREEN || wParam == SIZENORMAL)
      )
    {
     // Dimensiunile dreptunghiului de referinta "rc"
     rc.left =441;//(LOWORD(lParam) - cx) / 2;
     rc.top = HIWORD (lParam)*3/4-cy/2;
     MoveWindow (hwndButton,rc.left, rc.top, cx, cy, TRUE);
     MoveWindow (hwndButton1,rc.left, rc.top-200, cx, cy, TRUE);
     UpdateWindow(hwnd);
    }
   return 0;
  break;
  case WM_PAINT:
   hdc=BeginPaint(hwnd,&ps);
   GetClientRect(hwnd,&rc);
   rc.top=1;rc.left=(rc.right+rc.left)/2-100;
   DrawText (hdc, "Graficul functiei ",
       -1, &rc,DT_SINGLELINE | DT_CENTER | DT_VCENTER);
   EndPaint (hwnd, &ps);
   return 0;
  break;

 } //end switch
 return DefWindowProc (hwnd, nMsg, wParam, lParam);
 }

int STDCALL WinMain (HINSTANCE hInst,
                     HINSTANCE hPrev,
                     LPSTR lpCmd,
                     int nShow)
 {
  HWND hwndMain;/* "Handle", identificator al ferestrei principale*/
  MSG msg;/* O structura a mesajelor Win32 */
  WNDCLASSEX wndclass;/* O structura a clasei ferestrei */
  char*szMainWndClass = "WinTestWin"; /*  Eticheta cu numele ferestrei */
/*   La inceput cream clasa aferenta ferestrei noastre */

/* Initializeaza la 0 intreaga structura */
  memset (&wndclass, 0, sizeof(WNDCLASSEX));

/* Numele clasei este WinTestWin */
  wndclass.lpszClassName = szMainWndClass;

/*  cbSize da dimensiunea structurii pentru extensibilitate */
  wndclass.cbSize = sizeof(WNDCLASSEX);

/*  Toate ferestrele acestei clase sunt redesenate 
    la redimensionare */
  wndclass.style = CS_HREDRAW | CS_VREDRAW;

/*  Toate ferestrele acestei clase folosesc functia 
    MainWndProc */
  wndclass.lpfnWndProc = MainWndProc;

/*  Clasa ferestrei este asociata acestei ferestre */
  wndclass.hInstance = hInst;

/*  Foloseste icoana si cursoarele standard
    ale sistemului de operare */
  wndclass.hIcon = LoadIcon (NULL, IDI_APPLICATION);
  wndclass.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
  wndclass.hCursor = LoadCursor (NULL, IDC_ARROW);

/*  Culoarea de fond este alb */
  wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);

/*  Inregistreaza fereastra */
  RegisterClassEx (&wndclass);

/*  Creaza fereastra principala  */
  hwndMain = CreateWindow (
    szMainWndClass,/* Numele ferestrei (clasei)*/
    "Graficul unei functii",/* Eticheta ferestrei */
    WS_OVERLAPPEDWINDOW,/* Stiul */
    CW_USEDEFAULT,/* x initial (foloseste valoarea implicita) */
    CW_USEDEFAULT,/* y initial (foloseste valoarea implicita) */
    CW_USEDEFAULT,/* dimensiunea x initiala (foloseste valoarea implicita) */
    CW_USEDEFAULT,/* dimensiunea y initiala (foloseste valoarea implicita) */
    NULL,/* Nu avem fereastra parinte */
    NULL,/* Fara meniu */
    hInst,/* "Instanta" acestui program */
    NULL/* Parametri de creatie */
    );
/*  Afiseaza fereastra creata, folosind nShow, 
    care permite pornirea cu fereastra minimizata */
  ShowWindow (hwndMain, nShow);
  UpdateWindow (hwndMain);
/*  Principala bucla de mesaje. Toate mesajele trimise catre 
    sistemul de operare sunt receptionate prin apelarea functiei 
    GetMessage care sunt apoi retranmise procedurii corespunzatoare 
    din programul utilizatorului. Aceasta este cea mai simpla bucla
    de mesaj. Cand una dintre ferestre cheama PostQuitMessage, 
    functia GetMessage returneaza 0 si parametrul wParam al mesajului
    va contine argumentul dat de PostQuitMessage. Bucla va fi terminata
    iar aplicatia inchisa */
  while (GetMessage (&msg, NULL, 0, 0))
   {
    TranslateMessage (&msg);
    DispatchMessage (&msg);
   }
  return msg.wParam;
 }

