#include<math.h>
#include<stdio.h>
#include<conio.h>
#define n 1
#define np1 2
#define nsig 5
/*
 * Rezolvarea unui sistem neliniar de ecuatii
 */
double MAX(double x, double y)
{
	if (x>y) return x; else return y;
}

void sistem(double y[np1],double x[np1])
{ 
	double xp=x[0]*x[0],yp=x[1]*x[1];
	y[0]=xp*x[0]-3*x[0]*yp-2*x[0]+2;
	y[1]=3*xp*x[1]-x[1]*yp-2*x[1];
}

double gauss(double a[np1][np1], double b[np1], int iperm[np1])
{
	int k,l,i,j,it;
	double t,f=1.0;
	for (k=0;k<n;k++)
	{
    //pivotarea partiala
		for (l=k,i=k;i<=n;i++)if (fabs (a[i][k])>fabs (a[l][k]))l=i;
		if (l!=k)
		{
			for (j=k;j<=n;j++)
			{
		 		t=a[k][j];
		 		a[k][j]=a[l][j];
		 		a[l][j]=t;
			}
		t=b[k];
		it=iperm[k];
		b[k]=b[l];
		iperm[k]=iperm[l];
		b[l]=t;
		iperm[l]=it;
		f *= -1.0 ;
		}//pivotare
  	for (i=k+1 ;i <= n ; i++ )
		{
			t=a[i][k]/a[k][k];
			a[i][k]=t;
			for (j=k+1 ; j<=n; a[i][j]-= t*a[k][j],j++ );
			b[i]-=t*b[k];
		}
	}//k
	return f ;
}

int solutii(double a[np1][np1],double b[np1], double x[np1])
{
	int i,j;
	double t;
	for (i=0 ; i <= n; x[i]=0 ,i++ );
	x[n]=b[n]/a[n][n];
	for (i=n-1;i>=0;i--)
	{
		for (t=0,j=i+1;j<=n;j++)t+=a[i][j]*x[j];
		x[i]=(b[i]-t)/a[i][i];
		//printf("\nx[%d]=%lf",i,x[i]);
	}
	return ( 0 );
}

main ()
{
	double a[np1][np1];
	double x1[np1],x2[np1]={ 123456 , 33112435 },b[np1],y[np1],y1[np1];
	double reps=1,eps,pas,prec,t;
	int			i,j,iquit,k,iperm[np1];
	// clrscr ();//Borland
	for ( i=0 ; i <= n ; iperm[i] = i , i++);
	while (1 + reps != 1 ) reps /= 2 ;
	eps = sqrt ( reps * 2 );
	prec = pow ( 10 , -nsig ) ;
	while ( iquit != np1 )
	{
		for ( i=0 ; i<=n ; x1[i]=x2[i] , i++ );
	 	sistem(y1,x1);//sistem(&y1,&x1);//Borland
	 	for (j=0 ; j<=n ;j++ )
		{
			pas = MAX (0.1 , x1[j] )*eps;
			t = x1[j];
			x1[j]+=pas;
			sistem(y,x1);//sistem(&y,&x1);//Borland
			x1[j]=t;
			for ( i=0 ; i <= n ; i++ ) a[i][j]= ( y[i]-y1[i] )/pas;
		}
		t = gauss(a,y1,iperm);//gauss(&a,&y1,&iperm);//Borland
		t =solutii(a,y1,x2);// solutii(&a,&y1,&x2);//Borland
		for ( i=0 ; i <= n ; i++ ) x2[i] = x1[i] - x2[i];
  	//printf("\nx[1]=%lf x[2]=%lf",x2[1],x2[2]);
		iquit=0;
		for ( i=0 ; i <= n ; i++)
		    	if ( fabs ( x2[i]/x1[i]-1 ) < prec ) iquit++;
	}
	for ( i=0 ; i<=n ; i++ ) printf ("\nx[%d]=%lf",i,x2[i]);
	getch ();
	return 0 ;
}