
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "dislin.h"

float xray[100], yray[100], y1ray[100], y2ray[100];

main ()
{ int n = 100, i;
  double fpi = 3.1415926/180., step, x;

  step = 360. / (n-1);

  for (i = 0; i < n; i++)
  { xray[i] = i * step;
    x = xray[i] * fpi;
    y1ray[i] = sin(x);
    y2ray[i] = cos(x);
  }
  //metafl("tiff");
  metafl("xwin");
  disini();
  pagera();
  complx();
  axspos(450,1800);
  axslen(2200,1200);

  name("X-axis","x");
  name("Y-axis","y");

  labdig(-1,"x");
  ticks(10,"xy");

  titlin("Demonstration of CURVE",1);
  titlin("SIN(X), COS(X)",3);
//pagfll(255);//umple cu alb
  graf(0.,360.,0.,90.,-1.,1.,-1.,0.5);
  title();

  color("red");
  curve(xray,y1ray,n);
  color("green");
  curve(xray,y2ray,n);

  color("fore");

  dash();
  xaxgit();

  disfin();
  system("pause");

  return 0;
}

